;;===================================================================================
;; gdm_m1_kegelsenkung.lsp
;; erstellt: os / 17.02.2004
;; geaendert: os / 18.01.2008 15:38
;; * DIN 66, Beschriftung u. Flaechenfarbe hinzu
;; * Umstellung von prompt-variable zu next-variable
;;   Dadurch wird die Tabelle automatisch geoeffnet
;;===================================================================================

(in-package  :GDM)
(use-package :OLI)

(sd-create-logical-table "Kegelsenkung"
   :columns     '(  :SCHRAUBE  :NORM     :FORM    :GROESSE :BOHR_D  :SENK_D  :SENK_T1  :SENK_T2)
   :columnNames '(  "fuer/for"  "NORM"    "Form"   "Size"   "Diam D1"   "Diam D2"   "t1 ~"    "t2")
   :types       '(  :string    :string   :string  :string  :length  :length  :length   :length)
   :units       '(  nil        nil       nil      nil      :mm      :mm      :mm       :mm)
   :contents    '(
                   ;; DIN 74-Am
                   ("M2"       "DIN 74"  "Am"     "2"      2.4      4.6      1.1       0.0 )
                   ("M2,5"     "DIN 74"  "Am"     "2,5"    2.9      5.7      0.0       0.0 )
                   ("M3"       "DIN 74"  "Am"     "3"      3.4      6.5      1.6       0.0 )
                   ("M4"       "DIN 74"  "Am"     "4"      4.5      8.6      2.1       0.0 )
                   ("M5"       "DIN 74"  "Am"     "5"      5.5      10.4     2.5       0.0 )
                   ("M6"       "DIN 74"  "Am"     "6"      6.6      12.4     2.9       0.0 )
                   ("M8"       "DIN 74"  "Am"     "8"      9.0      16.4     3.7       0.0 )
                   ("M10"      "DIN 74"  "Am"     "10"     11.0     20.4     4.7       0.0 )
                   ("M12"      "DIN 74"  "Am"     "12"     13.5     23.9     5.2       0.0 )
                   ("M14"      "DIN 74"  "Am"     "14"     15.5     26.9     5.7       0.0 ) 
                   ("M16"      "DIN 74"  "Am"     "16"     17.5     31.9     7.2       0.0 )
                   ("M18"      "DIN 74"  "Am"     "18"     20.0     36.4     8.2       0.0 )
                   ("M20"      "DIN 74"  "Am"     "20"     22.0     40.4     9.2       0.0 )
                   ;; DIN 74-Af
                   ("M2"       "DIN 74"  "Af"     "2"      2.2      4.3      1.2       0.25)
                   ("M2,5"     "DIN 74"  "Af"     "2,5"    2.7      5.0      1.5       0.35)
                   ("M3"       "DIN 74"  "Af"     "3"      3.2      6.0      1.7       0.35)
                   ("M4"       "DIN 74"  "Af"     "4"      4.3      8.0      2.2       0.4 )
                   ("M5"       "DIN 74"  "Af"     "5"      5.3      10.0     2.6       0.3 )
                   ("M6"       "DIN 74"  "Af"     "6"      6.4      11.5     3.0       0.55)
                   ("M8"       "DIN 74"  "Af"     "8"      8.4      15.0     4.0       0.8 )
                   ("M10"      "DIN 74"  "Af"     "10"     10.5     19.0     5.0       0.8 )
                   ("M12"      "DIN 74"  "Af"     "12"     13.0     23.0     5.7       0.8 )
                   ("M14"      "DIN 74"  "Af"     "14"     15.0     26.0     6.2       0.8 )
                   ("M16"      "DIN 74"  "Af"     "16"     17.0     30.0     7.7       1.3 )
                   ("M18"      "DIN 74"  "Af"     "18"     19.0     34.0     8.7       1.3 )
                   ("M20"      "DIN 74"  "Af"     "20"     21.0     37.0     9.7       1.8 )
                   ;; DIN 74-Bm
                   ("M3"       "DIN 74"  "Bm"     "3"      3.4      6.6      1.6       0.0 )
                   ("M4"       "DIN 74"  "Bm"     "4"      4.5      9.0      2.3       0.0 )
                   ("M5"       "DIN 74"  "Bm"     "5"      5.5      11.0     2.8       0.0 )
                   ("M6"       "DIN 74"  "Bm"     "6"      6.6      13.0     3.2       0.0 )
                   ("M8"       "DIN 74"  "Bm"     "8"      9.0      17.2     4.1       0.0 )
                   ("M10"      "DIN 74"  "Bm"     "10"     11.0     21.5     5.3       0.0 )
                   ("M12"      "DIN 74"  "Bm"     "12"     13.5     25.5     6.0       0.0 )
                   ("M14"      "DIN 74"  "Bm"     "14"     15.5     28.5     6.5       0.0 )
                   ("M16"      "DIN 74"  "Bm"     "16"     17.5     31.5     7.0       0.0 )
                   ("M18"      "DIN 74"  "Bm"     "18"     20.0     35.0     7.5       0.0 )
                   ("M20"      "DIN 74"  "Bm"     "20"     22.0     38.0     8.0       0.0 )
                   ;; DIN 74-Bf
                   ("M3"       "DIN 74"  "Bf"     "3"      3.2      6.3      1.7       0.3 )
                   ("M4"       "DIN 74"  "Bf"     "4"      4.3      8.3      2.4       0.4 )
                   ("M5"       "DIN 74"  "Bf"     "5"      5.3      10.4     2.9       0.4 )
                   ("M6"       "DIN 74"  "Bf"     "6"      6.4      12.4     3.3       0.4 )
                   ("M8"       "DIN 74"  "Bf"     "8"      8.4      16.5     4.4       0.5 )
                   ("M10"      "DIN 74"  "Bf"     "10"     10.5     20.5     5.5       0.6 )
                   ("M12"      "DIN 74"  "Bf"     "12"     13.0     25.0     6.5       0.6 )
                   ("M14"      "DIN 74"  "Bf"     "14"     15.0     28.0     7.0       0.6 )
                   ("M16"      "DIN 74"  "Bf"     "16"     17.0     31.0     7.5       0.6 )
                   ("M18"      "DIN 74"  "Bf"     "18"     19.0     34.0     8.0       0.6 )
                   ("M20"      "DIN 74"  "Bf"     "20"     21.0     37.0     8.5       0.6 )
                   ;; DIN 66
                   ("M2"       "DIN 66"  ""      "2"       2.4      4.4      1.1       0.0 )
                   ("M3"       "DIN 66"  ""      "3"       3.4      6.3      1.6       0.0 )
                   ("M4"       "DIN 66"  ""      "4"       4.5      9.4      2.6       0.0 )
                   ("M5"       "DIN 66"  ""      "5"       5.5      10.4     2.6       0.0 )
                   ("M6"       "DIN 66"  ""      "6"       6.6      12.6     3.1       0.0 )
                   ("M8"       "DIN 66"  ""      "8"       9.0      17.3     4.3       0.0 )
                   ("M10"      "DIN 66"  ""      "10"      11.0     20.0     4.7       0.0 )
                   ("M12"      "DIN 66"  ""      "12"      13.5     24.0     5.4       0.0 )
                   ("M16"      "DIN 66"  ""      "16"      17.5     32.0     7.5       0.0 )
                   ("M18"      "DIN 66"  ""      "18"      20.0     36.0     8.2       0.0 )
                   ("M20"      "DIN 66"  ""      "20"      22.0     40.0     9.2       0.0 )
                 );;contents
);;sd-create-logical-table

(sd-create-display-table
     "Kegelsenkung"
     :tableTitle        (sd-multi-lang-string "Counterbore" :german "Kegelsenkung")
     :logicalTable      "Kegelsenkung"
     :columns           '(:SCHRAUBE :NORM :FORM :GROESSE :BOHR_D :SENK_D :SENK_T1 :SENK_T2)
     :applyColumns      '(:BOHR_D :NORM :FORM :GROESSE :SENK_D :SENK_T1 :SENK_T2)
     :displayHeight     730
     ;:columnSortUI      t
     :filterStatusLine  nil
     :selectionMode     :single-row
     :applyAction       :default-tokens
)

(sd-defdialog 'gdm-m1-kegelsenkung-dialog
  :dialog-title (sd-multi-lang-string "Counterbore" :german "Kegelsenkung")
  :toolbox-button t
  :variables
  '(
    (POINT_LIST)

    (BILD
     :value-type :image
;     :image-file (format nil "~a/LISP/gdm_m1_kegelsenkung.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
     :image-file "C:/ ... PFAD ANPASSEN ... /gdm_m1_kegelsenkung.bmp")

    ("")

    (A_PART
     :value-type :part-incl-new
     :modifies :contents
     :title (sd-multi-lang-string "Part" :german "Teil")
     :prompt-text (sd-multi-lang-string "Specify Part." :german "Teil angeben.")
     :next-variable 'PNT_1)

    (AKT_WP
     :value-type :wp
     :title (sd-multi-lang-string "Workplane" :german "AEbene")
     :prompt-text (sd-multi-lang-string "Specify Workplane." :german "Arbeitsebene angeben.")
     :next-variable 'PNT_1)

    ("")

    (BOHR_D
     :value-type :positive-number
     :title "Diam D1"
     :show-input-tool (sd-show-display-table "Kegelsenkung" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 330 250))
     :hide-input-tool (sd-hide-display-table "Kegelsenkung" :ignorePin t)
     :prompt-text (sd-multi-lang-string "Specify Diameter D1." :german "Durchmesser D1 angeben.")
     :next-variable 'PNT_1)

    (SENK_D
     :value-type :positive-number
     :title "Diam D2"
     :show-input-tool (sd-show-display-table "Kegelsenkung" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 330 250))
     :hide-input-tool (sd-hide-display-table "Kegelsenkung" :ignorePin t)
     :prompt-text (sd-multi-lang-string "Specify Diameter D2." :german "Durchmesser D2 angeben.")
     :next-variable 'PNT_1)

    (SENK_T1
     :value-type :number
     :title "t1"
     :show-input-tool (sd-show-display-table "Kegelsenkung" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 330 250))
     :hide-input-tool (sd-hide-display-table "Kegelsenkung" :ignorePin t)
     :prompt-text (sd-multi-lang-string "Specify Depth t1." :german "Senkungstiefe t1 angeben.")
     :next-variable 'PNT_1)

    (SENK_T2
     :value-type :number
     :title "t2"
     :show-input-tool (sd-show-display-table "Kegelsenkung" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 330 250))
     :hide-input-tool (sd-hide-display-table "Kegelsenkung" :ignorePin t)
     :prompt-text (sd-multi-lang-string "Specify Depth t2." :german "Senkungstiefe t2 angeben.")
     :next-variable 'PNT_1)

    ;; invisible
    (NORM
     :value-type :string
     :toggle-type :invisible
    )

    (FORM
     :value-type :string
     :toggle-type :invisible
    )

    (GROESSE
     :value-type :string
     :toggle-type :invisible
    )
    ;; end invisible

    ("")

    (PNT_1
     :value-type :point-2d ;:point-3d-pick
     :title (sd-multi-lang-string "Point" :german "Punkt")
     :toggle-type :invisible
     :prompt-text (sd-multi-lang-string "Specify Point or Back." :german "Punkt angeben oder Zurueck.")
     :after-input
       (progn
         (push-point pnt_1)
         (sd-call-cmds (c_point pnt_1))
       );;progn
     :next-variable 'PNT_1)

    (ANZAHL
     :title (sd-multi-lang-string "Quantity" :german "Anzahl")
     :value-type :display-only
     :initial-value 0
     :display-units :length)

    (BACK
     :title (sd-multi-lang-string "Back" :german "Zurueck")
     :push-action (pop-point)
     :next-variable 'PNT_1)

  );;variables

  ;:prompt-variable 'PNT_1

  :local-functions
  '(
    ;;=========
    (PUSH-POINT (a-new-point)
         (push a-new-point POINT_LIST)
         (setq ANZAHL (+ ANZAHL 1))
    );;PUSH-POINT

    ;;=========
    (POP-POINT ()
         (pop POINT_LIST)
         (setq ANZAHL (- ANZAHL 1))
         (if (< ANZAHL 0)
             (setq ANZAHL 0)
         );;if
         (unless point_list
           (sd-set-variable-status 'back :enable nil))
    );;POP-POINT

    ;;=========
    (OS-kegelsenkung-erstellen ()
      (sd-call-cmds
       (progn
         (if (/= ANZAHL 0)
           (progn
             (let (P1)
               (dolist (P1 POINT_LIST)
                 (let (old-faces new-faces)
                      (sd-call-cmds (current_part A_PART))
                      ;;Liste 1 aller Flaechen des aktuellen Teils erstellen
                      (sd-call-cmds (get_selection  :focus_type *sd-face-seltype* :curr_part_only :select :all_3d)
                                                    :failure (setf old-faces nil)
                                                    :success (setf old-faces *SD-ACTION-RESULT*))
                      ;;Arbeitsebene erstellen
                      (create_workplane :copy :source AKT_WP :name "AE_tmp" :owner "/") (slide_wp_origin (sd-inq-curr-wp) P1)
                      ;;Profil und H-Geo loeschen
                      (sd-call-cmds (delete_2d :current_wp :edge_2d :all_2d) :failure nil)
                      ;;Geo fuer Durchgangsbohrung erstellen
                      (geometry_mode :real)
                      (circle :cen_rad 0,0 (/ BOHR_D 2))
                      ;;Lochen
                      (punch :parts A_PART :wp (sd-inq-curr-wp) :keep_wp :yes :keep_profile :no)
                      ;;AE um 90 Grad drehen
                      (position_wp :workplane (sd-inq-curr-wp) :rotate :axis :u :rotation_angle (/ pi 2) :done)
                      ;;Profil fuer Senkung erstellen
                      (polygon
                          (gpnt2d 0 1.0)
                          (gpnt2d (/ SENK_D 2.0) 1.0)
                          (gpnt2d (/ SENK_D 2.0) (* -1 SENK_T2))
                          (gpnt2d 0 (* -1 (+ SENK_T2 (/ SENK_D 2.0)))) :close)
                      ;;abdrehen
                      (sd-call-cmds (bore  :parts A_PART :axis :v :rotation_angle (* 2 pi) :keep_profile :no :keep_wp :no))
                      ;;Liste 2 aller Flaechen des aktuellen Teils erstellen
                      (sd-call-cmds (get_selection :focus_type *sd-face-seltype* :curr_part_only :select :all_3d) 
                                                   :failure (setf new-faces nil)
                                                   :success (setf new-faces *SD-ACTION-RESULT*))
                      ;; Liste 1 und 2 vergleichen und die neuen Flaechen einfaerben
                      (if (null new-faces)
                          (sd-display-message (sd-multi-lang-string "Error! There are no new Surfaces." :german "Fehler! Das Modell hat keine neuen Flaechen."))
                          (dolist (a-face new-faces)
                            ;;neue Flaechen suchen
                            (when (not (member a-face old-faces :test #'equal))
                                  ;;Flaechenfarbe setzen
                                  ;(sd-call-cmds (set_face_color a-face (sd-rgb-to-color 1,0,0)))
                                  ;;label hinzufuegen
                                  (when (sd-cylinder-p (sd-inq-geo-props a-face :dest-space :global))
                                        (if (= (sd-cylinder-radius (sd-inq-geo-props a-face :dest-space :global)) (/ BOHR_D 2)) 
                                            (if (string= FORM "")
                                                (Cocreate_3d_note :action :create :items a-face :note (format nil "~a-~a" NORM GROESSE))
                                                (Cocreate_3d_note :action :create :items a-face :note (format nil "~a-~a~a" NORM FORM GROESSE))
                                            );;if
                                        );;if   
                                  );;when
                            );;when
                          );;dolist
                       );;if
                 );;let
               );;dolist
             );;let
             ;;Urspungs AE aktiv setzen
             (current_wp AKT_WP)
           );;progn
         );;if
         ;;Hilfspunkte loeschen - Fehlermeldung unterdruecken
         (sd-call-cmds (delete_2d :c_user_point :all_2d) :failure nil)
       );;progn
      );;sd-call-cmds
    );;OS-kegelsenkung-erstellen

    (OS-c-geo-punkte-loeschen ()
       (sd-call-cmds (delete_2d :c_user_point :all_2d) :failure nil)
    )

  );;:local-functions

 :ok-action '(OS-kegelsenkung-erstellen)

 :cancel-action '(OS-c-geo-punkte-loeschen)

 :help-action '(sd-display-url (format nil "file:~a/LISP/gdm_m1_kegelsenkung.mht" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))

);;sd-defdialog
